=== debian/changelog ===
photoqt (4.2+ds-3) unstable; urgency=medium

  * Add missing Depends.

 -- Gürkan Myczko <tar@debian.org>  Mon, 05 Feb 2024 08:40:35 +0100

photoqt (4.2+ds-2) unstable; urgency=medium

  * Disable libresvg-dev support.

 -- Gürkan Myczko <tar@debian.org>  Wed, 24 Jan 2024 14:58:36 +0100

photoqt (4.2+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add libresvg-dev to build-depends.
  * d/rules: enable resvg usage.

 -- Gürkan Myczko <tar@debian.org>  Wed, 24 Jan 2024 12:16:22 +0100

photoqt (4.0.1+ds-1) unstable; urgency=medium

  * Ack NMU, dropped patches/ as upstreamed.
  * New upstream version.
  * d/control: build-depends add qt6-svg-dev, libpoppler-qt6-dev, and some
    more qt6 dependencies, drop all qt5 dependencies.
  * d/copyright: add windowsicons.rc to Files-Excluded, drop snap.

 -- Gürkan Myczko <tar@debian.org>  Mon, 18 Dec 2023 07:52:42 +0100
