## photoqt 4.4%2Bds

=== debian/changelog ===
photoqt (4.4+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add liblcms2-dev to build-depends.

 -- Gürkan Myczko <tar@debian.org>  Mon, 08 Apr 2024 14:03:28 +0200

photoqt (4.3+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/control: add build-depends libzxing-dev.

 -- Gürkan Myczko <tar@debian.org>  Mon, 18 Mar 2024 00:38:13 +0100
