## photoqt 4.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.2")
+SET(APPVERSION "4.4")
 add_definitions(-DPQMVERSION="${APPVERSION}")
 
 ########################################
@@ -47,6 +47,7 @@
 option(VIDEO_MPV "Enable video support through MPV" ON)
 option(LIBVIPS "Use libvips" OFF)
 option(RESVG "Replace Qt's SVG engine with resvg for better SVG support" OFF)
+option(ZXING "Support for QR and barcodes detection (using ZXing)" ON)
 
 option(EXIV2 "Use exiv2 library" ON)
 option(EXIV2_ENABLE_BMFF "Enable BMFF format support in Exiv2 (if available)" ON)
@@ -55,14 +56,18 @@
 option(CHROMECAST_PIPINSTALL "Allows CMake to attempt to install PyChromecast locally using pip." OFF)
 option(LOCATION "Enable use of QtPositioning/QtLocation QML modules" ON)
 option(MOTIONPHOTO "Enable support for Google Motion Photos and Apple Live Photos" ON)
+option(PHOTOSPHERE "Enable support for photo spheres and 360 degree panoramic views" ON)
+option(LCMS2 "Enable advanced color management with LCMS2" ON)
 
 option(TESTING "Build some unit tests" OFF)
 option(RUNCPPCHECK "Analyse source code with cppcheck" OFF)
+option(FLATPAKBUILD "Enable this if this is a build for Flatpak" OFF)
 
 if(QTPDF)
     if(POPPLER)
         set(POPPLER OFF)
-        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF")
+        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF.")
+        message("** Poppler has been automatically disabled in favour of QtPDF.")
     endif()
 endif()
 
@@ -84,7 +89,8 @@
     find_package(ImageMagick COMPONENTS Magick++)
     if(GRAPHICSMAGICK)
         set(GRAPHICSMAGICK OFF)
-        message("** ImageMagick and GraphicsMagick cannot be used at the same time")
+        message("** ImageMagick and GraphicsMagick cannot be used at the same time.")
+        message("** GraphicsMagick has been automatically disabled in favour of ImageMagick.")
     endif()
 endif()
 
@@ -136,6 +142,28 @@
 
 if(QTPDF)
     find_package(Qt6 COMPONENTS Pdf REQUIRED)
+endif()
+
+if(ZXING)
+    find_package(ZXing)
+endif()
+
+if(PHOTOSPHERE)
+    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_real.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
+    set(photoqt_SOURCES ${photoqt_SOURCES} ${photoqt_ps_SOURCES})
+else()
+    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
+                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_fake.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
+endif()
+
+if(LCMS2)
+    find_package(LCMS2)
+endif()
+
+if(FLATPAKBUILD)
+    find_package(PkgConfig REQUIRED)
+    pkg_search_module(GLIB REQUIRED glib-2.0 gobject-2.0 gio-2.0)
 endif()
 
 ######################
@@ -156,6 +184,7 @@
         list(APPEND CMAKE_CXX_CPPCHECK
                 "--enable=warning"
                 "--inconclusive"
+                "--library=qt"
         )
 
     endif()
@@ -203,7 +232,7 @@
 endif()
 
 # add qml files
-qt_add_qml_module(photoqt URI src VERSION 1.0 QML_FILES ${photoqt_QML})
+qt_add_qml_module(photoqt URI src VERSION 1.0 QML_FILES ${photoqt_QML} RESOURCE_PREFIX)
 
 # set header files as include files
 target_include_directories(photoqt PRIVATE "cplusplus/header")
@@ -345,43 +374,3 @@
             message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
         else()
             message("** Using FreeImage")
-            include_directories(${FREEIMAGE_INCLUDE_DIRS})
-            add_definitions(-DPQMFREEIMAGE)
-            target_link_libraries(photoqt PRIVATE ${FREEIMAGE_C_LIBRARY})
-            if(TESTING)
-                target_link_libraries(photoqt_test PRIVATE ${FREEIMAGE_C_LIBRARY})
-            endif()
-        endif()
-    endif()
-else()
-    message("** FreeImage DISABLED")
-endif()
-
-if(RAW)
-    if(NOT ${LIBRAW_FOUND})
-        message(FATAL_ERROR "** Unable to locate LibRaw... is it installed?")
-    else()
-        message("** Using LibRaw")
-        add_definitions(-DPQMRAW)
-        include_directories(${LIBRAW_INCLUDE_DIR})
-        if(WIN32)
-            target_link_libraries(photoqt PRIVATE "libraw")
-            if(TESTING)
-                target_link_libraries(photoqt_test PRIVATE "libraw")
-            endif()
-        else()
-            target_link_libraries(photoqt PRIVATE "raw")
-            if(TESTING)
-                target_link_libraries(photoqt_test PRIVATE "raw")
-            endif()
-        endif()
-    endif()
-else()
-    message("** LibRaw DISABLED")
-endif()
-
-if(EXIV2)
-    if(NOT ${exiv2_FOUND})
-        message(FATAL_ERROR "** Unable to locate Exiv2... is it installed?")
-    else()
-        message("** Using Exiv2 ${exiv2_VERSION}")
