=== debian/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
  libpugixml-dev,
  libpoppler-qt6-dev,
  libpoppler-private-dev,
+ libzxing-dev,
  qt6-svg-dev,
  python3-pip,
  python3-dev,
