## photoqt 4.5+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.4")
+SET(APPVERSION "4.5")
 add_definitions(-DPQMVERSION="${APPVERSION}")
 
 ########################################
@@ -149,12 +149,7 @@
 endif()
 
 if(PHOTOSPHERE)
-    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_real.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
     set(photoqt_SOURCES ${photoqt_SOURCES} ${photoqt_ps_SOURCES})
-else()
-    execute_process(COMMAND ${CMAKE_COMMAND} -E copy_if_different
-                   "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere_fake.qml" "${CMAKE_CURRENT_SOURCE_DIR}/qml/image/PQPhotoSphere.qml")
 endif()
 
 if(LCMS2)
@@ -374,3 +369,17 @@
             message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
         else()
             message("** Using FreeImage")
+            include_directories(${FREEIMAGE_INCLUDE_DIRS})
+            add_definitions(-DPQMFREEIMAGE)
+            target_link_libraries(photoqt PRIVATE ${FREEIMAGE_C_LIBRARY})
+            if(TESTING)
+                target_link_libraries(photoqt_test PRIVATE ${FREEIMAGE_C_LIBRARY})
+            endif()
+        endif()
+    endif()
+else()
+    message("** FreeImage DISABLED")
+endif()
+
+if(RAW)
+    if(NOT ${LIBRAW_FOUND})
