=== debian/changelog ===
photoqt (4.5+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Sun, 19 May 2024 23:06:19 +0200
