## photoqt 4.6+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.5")
+SET(APPVERSION "4.6")
 add_definitions(-DPQMVERSION="${APPVERSION}")
 
 ########################################
