=== debian/changelog ===
photoqt (4.6+ds-1build1) plucky; urgency=medium

  * No-change rebuild for libexiv2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Nov 2024 12:17:48 +0000

photoqt (4.6+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Sun, 11 Aug 2024 07:17:50 +0000
