## photoqt 4.8.1+ds

=== CMakeLists.txt ===
##############################################
# CMakeLists for PhotoQt: http://photoqt.org #
##############################################

cmake_minimum_required(VERSION 3.26)
project(photoqt LANGUAGES CXX)

##################################################################
####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
##################################################################

SET(APPVERSION "4.8.1")

########################################
####  SOME SETTINGS/FLAGS FOR CMAKE ####
########################################

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

#############################
####  GET list of files  ####
#############################

include(CMake/ListFilesCPlusPlus.cmake)
include(CMake/ListFilesQML.cmake)

#############################################
#### OPTIONS THAT CAN BE SET BY THE USER ####
#############################################

option(WITH_IMAGEMAGICK           "Configure with support for the ImageMagick library" ON)
option(WITH_GRAPHICSMAGICK        "Configure with support for the GraphicsMagick library" OFF)
option(WITH_LIBRAW                "Configure with support for the libraw library" ON)
option(WITH_DEVIL                 "Configure with support for the DevIL library" ON)
option(WITH_FREEIMAGE             "Configure with support for the FreeImage library" ON)
option(WITH_POPPLER               "Configure with support for the Poppler library" ON)
option(WITH_QTPDF                 "Configure with support for the QtPDF module (instead of Poppler)" OFF)
option(WITH_LIBARCHIVE            "Configure with support for the libarchive library" ON)
option(WITH_VIDEO_QT              "Configure with video support through Qt" ON)
option(WITH_VIDEO_MPV             "Configure with video support through MPV" ON)
option(WITH_LIBVIPS               "Configure with support for the libvips library" OFF)
option(WITH_RESVG                 "Configure with support for the resvg library (better SVG support)" OFF)

option(WITH_EXIV2                 "Configure with support for the Exiv2 library" ON)
option(WITH_EXIV2_ENABLE_BMFF     "Configure with BMFF format support in Exiv2 (if available) - only needed for Exiv2 0.27.x and before" ON)
option(WITH_PUGIXML               "Configure with support for the pugixml library" ON)
option(WITH_ZXING                 "Configure with support for the ZXing library (QR and barcodes detection)" ON)
option(WITH_CHROMECAST            "Configure with support for Chromecast (through Python)" ON)
option(WITH_CHROMECAST_PIPINSTALL "Allows CMake to attempt to install PyChromecast locally using pip" OFF)
option(WITH_LOCATION              "Configure with support for the QtPositioning/QtLocation QML modules" ON)
option(WITH_LCMS2                 "Configure with support for the Little CMS library (advanced color management)" ON)
option(WITH_MOTIONPHOTO           "Configure with support for Google Motion Photos and Apple Live Photos" ON)
option(WITH_PHOTOSPHERE           "Configure with support for photo spheres and 360 degree panoramic views" ON)

option(WITH_TESTING               "Enable and build some unit tests" OFF)
option(WITH_RUNCPPCHECK           "Analyse source code with cppcheck" OFF)
option(WITH_FLATPAKBUILD          "Enable this option if this is a build for Flatpak" OFF)
option(WITH_ADAPTSOURCE           "Adapt and change the source files for the current Qt version (if necessary)" OFF)
option(WITHOUT_ICU                "Enable this option if your Qt6 setup has no ICU support" OFF)
option(WITH_PORTABLETWEAKS        "Apply tweaks for a build of a portable version" OFF)


##################################################################################################################
# The options above were renamed for 4.8.1
# For the time being we still check for the old names and pass any value on to the new options
if(DEFINED IMAGEMAGICK)
    message("** The IMAGEMAGICK option is deprecated, use WITH_IMAGEMAGICK instead: ${IMAGEMAGICK}")
    set(WITH_IMAGEMAGICK ${IMAGEMAGICK} CACHE BOOL "Configure with support for the ImageMagick library" FORCE)
    unset(IMAGEMAGICK CACHE)
endif()
if(DEFINED GRAPHICSMAGICK)
    message("** The GRAPHICSMAGICK option is deprecated, use WITH_GRAPHICSMAGICK instead")
    set(WITH_GRAPHICSMAGICK ${GRAPHICSMAGICK} CACHE BOOL "Configure with support the for GraphicsMagick library" FORCE)
    unset(GRAPHICSMAGICK CACHE)
endif()
if(DEFINED RAW)
    message("** The RAW option is deprecated, use WITH_LIBRAW instead")
    set(WITH_LIBRAW ${RAW} CACHE BOOL "Configure with support for the libraw library" FORCE)
    unset(RAW CACHE)
endif()
if(DEFINED DEVIL)
    message("** The DEVIL option is deprecated, use WITH_DEVIL instead")
    set(WITH_DEVIL ${DEVIL} CACHE BOOL "Configure with support for the DevIL library" FORCE)
    unset(DEVIL CACHE)
endif()
if(DEFINED FREEIMAGE)
    message("** The FREEIMAGE option is deprecated, use WITH_FREEIMAGE instead")
    set(WITH_FREEIMAGE ${FREEIMAGE} CACHE BOOL "Configure with support for the FreeImage library" FORCE)
    unset(FREEIMAGE CACHE)
endif()
if(DEFINED POPPLER)
    message("** The POPPLER option is deprecated, use WITH_POPPLER instead")
    set(WITH_POPPLER ${POPPLER} CACHE BOOL "Configure with support for the Poppler library" FORCE)
    unset(POPPLER CACHE)
endif()
if(DEFINED QTPDF)
    message("** The QTPDF option is deprecated, use WITH_QTPDF instead")
    set(WITH_QTPDF ${QTPDF} CACHE BOOL "Configure with support for the QtPDF module (instead of Poppler)" FORCE)
    unset(QTPDF CACHE)
endif()
if(DEFINED LIBARCHIVE)
    message("** The LIBARCHIVE option is deprecated, use WITH_LIBARCHIVE instead")
    set(WITH_LIBARCHIVE ${LIBARCHIVE} CACHE BOOL "Configure with support for the libarchive library" FORCE)
    unset(LIBARCHIVE CACHE)
endif()
if(DEFINED VIDEO_QT)
    message("** The VIDEO_QT option is deprecated, use WITH_VIDEO_QT instead")
    set(WITH_VIDEO_QT ${VIDEO_QT} CACHE BOOL "Configure with video support through Qt" FORCE)
    unset(VIDEO_QT CACHE)
endif()
if(DEFINED VIDEO_MPV)
    message("** The VIDEO_MPV option is deprecated, use WITH_VIDEO_MPV instead")
    set(WITH_VIDEO_MPV ${VIDEO_MPV} CACHE BOOL "Configure with video support through MPV" FORCE)
    unset(VIDEO_MPV CACHE)
endif()
if(DEFINED LIBVIPS)
    message("** The LIBVIPS option is deprecated, use WITH_LIBVIPS instead")
    set(WITH_LIBVIPS ${LIBVIPS} CACHE BOOL "Configure with support for the libvips library" FORCE)
    unset(LIBVIPS CACHE)
endif()
if(DEFINED RESVG)
    message("** The RESVG option is deprecated, use WITH_RESVG instead")
    set(WITH_RESVG ${RESVG} CACHE BOOL "Configure with support for the resvg library (better SVG support)" FORCE)
    unset(RESVG CACHE)
endif()
if(DEFINED EXIV2)
    message("** The EXIV2 option is deprecated, use WITH_EXIV2 instead")
    set(WITH_EXIV2 ${EXIV2} CACHE BOOL "Configure with support for the Exiv2 library" FORCE)
    unset(EXIV2 CACHE)
endif()
if(DEFINED EXIV2_ENABLE_BMFF)
    message("** The EXIV2_ENABLE_BMFF option is deprecated, use WITH_EXIV2_ENABLE_BMFF instead")
    set(WITH_EXIV2_ENABLE_BMFF ${EXIV2_ENABLE_BMFF} CACHE BOOL "Configure with BMFF format support in Exiv2 (if available) - only needed for Exiv2 0.27.x and before" FORCE)
    unset(EXIV2_ENABLE_BMFF CACHE)
endif()
if(DEFINED PUGIXML)
    message("** The PUGIXML option is deprecated, use WITH_PUGIXML instead")
    set(WITH_PUGIXML ${PUGIXML} CACHE BOOL "Configure with support for the pugixml library" FORCE)
    unset(PUGIXML CACHE)
endif()
if(DEFINED ZXING)
    message("** The ZXING option is deprecated, use WITH_ZXING instead")
    set(WITH_ZXING ${ZXING} CACHE BOOL "Configure with support for the ZXing library (QR and barcodes detection)" FORCE)
    unset(ZXING CACHE)
endif()
if(DEFINED CHROMECAST)
    message("** The CHROMECAST option is deprecated, use WITH_CHROMECAST instead")
    set(WITH_CHROMECAST ${CHROMECAST} CACHE BOOL "Configure with support for Chromecast (through Python)" FORCE)
    unset(CHROMECAST CACHE)
endif()
if(DEFINED CHROMECAST_PIPINSTALL)
    message("** The CHROMECAST_PIPINSTALL option is deprecated, use WITH_CHROMECAST_PIPINSTALL instead")
    set(WITH_CHROMECAST_PIPINSTALL ${CHROMECAST_PIPINSTALL} CACHE BOOL "Allows CMake to attempt to install PyChromecast locally using pip" FORCE)
    unset(CHROMECAST_PIPINSTALL CACHE)
endif()
if(DEFINED LOCATION)
    message("** The LOCATION option is deprecated, use WITH_LOCATION instead")
    set(WITH_LOCATION ${LOCATION} CACHE BOOL "Configure with support for the QtPositioning/QtLocation QML modules" FORCE)
    unset(LOCATION CACHE)
endif()
if(DEFINED LCMS2)
    message("** The LCMS2 option is deprecated, use WITH_LCMS2 instead")
    set(WITH_LCMS2 ${LCMS2} CACHE BOOL "Configure with support for the Little CMS library (advanced color management)" FORCE)
    unset(LCMS2 CACHE)
endif()
if(DEFINED MOTIONPHOTO)
    message("** The MOTIONPHOTO option is deprecated, use WITH_MOTIONPHOTO instead")
    set(WITH_MOTIONPHOTO ${MOTIONPHOTO} CACHE BOOL "Configure with support for Google Motion Photos and Apple Live Photos" FORCE)
    unset(MOTIONPHOTO CACHE)
endif()
if(DEFINED PHOTOSPHERE)
    message("** The PHOTOSPHERE option is deprecated, use WITH_PHOTOSPHERE instead")
    set(WITH_PHOTOSPHERE ${PHOTOSPHERE} CACHE BOOL "Configure with support for photo spheres and 360 degree panoramic views" FORCE)
    unset(PHOTOSPHERE CACHE)
endif()

if(DEFINED TESTING)
    message("** The TESTING option is deprecated, use WITH_TESTING instead")
    set(WITH_TESTING ${TESTING} CACHE BOOL "Enable and build some unit tests" FORCE)
    unset(TESTING CACHE)
endif()
if(DEFINED RUNCPPCHECK)
    message("** The RUNCPPCHECK option is deprecated, use WITH_RUNCPPCHECK instead")
    set(WITH_RUNCPPCHECK ${RUNCPPCHECK} CACHE BOOL "Analyse source code with cppcheck" FORCE)
    unset(RUNCPPCHECK CACHE)
endif()
if(DEFINED FLATPAKBUILD)
    message("** The FLATPAKBUILD option is deprecated, use WITH_FLATPAKBUILD instead")
    set(WITH_FLATPAKBUILD ${FLATPAKBUILD} CACHE BOOL "Enable this option if this is a build for Flatpak" FORCE)
    unset(FLATPAKBUILD CACHE)
endif()
if(DEFINED ADAPT_SOURCE)
    message("** The ADAPT_SOURCE option is deprecated, use WITH_ADAPTSOURCE instead")
    set(WITH_ADAPTSOURCE ${ADAPT_SOURCE} CACHE BOOL "Adapt and change the source files for the current Qt version (if necessary)" FORCE)
    unset(ADAPT_SOURCE CACHE)
endif()
if(DEFINED WITHOUTICU)
    message("** The WITHOUTICU option is deprecated, use WITHOUT_ICU instead")
    set(WITHOUT_ICU ${WITHOUTICU} CACHE BOOL "Enable this option if your Qt6 setup has no ICU support" FORCE)
    unset(WITHOUTICU CACHE)
endif()
##################################################################################################################
##################################################################################################################

#####################################
#### RESOLVE CONFLICTING OPTIONS ####
#####################################

if(WITH_QTPDF)
    if(WITH_POPPLER)
        set(WITH_POPPLER OFF)
        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF.")
        message("** Poppler has been automatically disabled in favour of QtPDF.")
    endif()
endif()

if(WITH_IMAGEMAGICK)
    if(WITH_GRAPHICSMAGICK)
        set(WITH_GRAPHICSMAGICK OFF)
        message("** ImageMagick and GraphicsMagick cannot be used at the same time.")
        message("** GraphicsMagick has been automatically disabled in favour of ImageMagick.")
    endif()
endif()

################################
#### FIND REQUIRED PACKAGES ####
################################

find_package(Qt6 6.4 REQUIRED COMPONENTS Quick Widgets Sql Core Svg Concurrent Multimedia PrintSupport DBus LinguistTools)
if(WITH_TESTING)
    find_package(Qt6 6.4 REQUIRED COMPONENTS Test)
endif()
