=== debian/changelog ===
photoqt (4.8.1+ds-1build2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Sep 2025 21:38:41 +0100

photoqt (4.8.1+ds-1build1) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:12:32 -0500

photoqt (4.8.1+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 17 Feb 2025 10:11:13 +0000

photoqt (4.6+ds-2) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/control: drop version from libmagick++-dev dependecy. (Closes: #1086940)

 -- Alex Myczko <tar@debian.org>  Wed, 20 Nov 2024 12:03:23 +0000
