=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: photoqt
 Section: graphics
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
  extra-cmake-modules,
  libexiv2-dev,
- libmagick++-6.q16-dev [!kfreebsd-amd64 !kfreebsd-i386],
+ libmagick++-dev [!kfreebsd-amd64 !kfreebsd-i386],
  libgraphicsmagick1-dev,
  libgraphicsmagick++1-dev,
  libraw-dev,
@@ -36,7 +37,7 @@
  qt6-multimedia-dev,
  qt6-declarative-dev,
  qt6-declarative-dev-tools
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://photoqt.org/
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git
