## photoqt 4.9.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,13 @@
 ##############################################
 
 cmake_minimum_required(VERSION 3.26)
-project(photoqt LANGUAGES CXX)
+project(photoqt LANGUAGES C CXX)
 
 ##################################################################
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-SET(APPVERSION "4.8.1")
+SET(APPVERSION "4.9.2")
 
 ########################################
 ####  SOME SETTINGS/FLAGS FOR CMAKE ####
@@ -29,6 +29,7 @@
 
 include(CMake/ListFilesCPlusPlus.cmake)
 include(CMake/ListFilesQML.cmake)
+include(CMake/ListFilesExtensions.cmake)
 
 #############################################
 #### OPTIONS THAT CAN BE SET BY THE USER ####
@@ -64,6 +65,7 @@
 option(WITH_ADAPTSOURCE           "Adapt and change the source files for the current Qt version (if necessary)" OFF)
 option(WITHOUT_ICU                "Enable this option if your Qt6 setup has no ICU support" OFF)
 option(WITH_PORTABLETWEAKS        "Apply tweaks for a build of a portable version" OFF)
+option(WITH_WAYLANDSPECIFIC      "Enable optional Wayland-specific code to allow for further optimizations." OFF)
 
 
 ##################################################################################################################
@@ -232,8 +234,3 @@
 #### FIND REQUIRED PACKAGES ####
 ################################
 
-find_package(Qt6 6.4 REQUIRED COMPONENTS Quick Widgets Sql Core Svg Concurrent Multimedia PrintSupport DBus LinguistTools)
-if(WITH_TESTING)
-    find_package(Qt6 6.4 REQUIRED COMPONENTS Test)
-endif()
-
