=== debian/changelog ===
photoqt (4.9.2+ds-1) unstable; urgency=medium

  * Team upload.
  * d/watch: add opts for repacksuffix +ds
  * New upstream version 4.9.2+ds
  * Bump Standards-Version: 4.7.2
  * d/copyright: add License: CC0-1.0 for org.photoqt.PhotoQt.metainfo.xml

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 26 Aug 2025 17:42:44 +0800
