=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: photoqt
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
@@ -37,7 +36,7 @@
  qt6-multimedia-dev,
  qt6-declarative-dev,
  qt6-declarative-dev-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://photoqt.org/
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git
