=== debian/watch ===
version=4

opts="dversionmangle=s/\.ds//,repack,repacksuffix=+ds" \
   https://github.com/luspi/photoqt/tags .*/v?(\d\S+)\.tar\.gz
